;;;; srfi-19-period.comparator.scm  -*- Scheme -*-
;;;; Kon Lovett, Dec '21

(module srfi-19-period.comparator

(;export
  time-period-hash
  make-time-period-comparator)

(import scheme
  (chicken base)
  (chicken type)
  (only (chicken bitwise) bitwise-xor)
  (only (srfi 128) number-hash make-comparator)
  (only srfi-19-period time-period-begin time-period-end time-period? time-period=? time-period<? check-time-period)
  (only (srfi-19-time comparator) time-hash))

;;;

(include-relative "srfi-19-common.types")

(: time-period-hash (time-period --> integer))
(: make-time-period-comparator (--> (struct comparator)))

;;;

(define (time-period-hash prd)
  (floor (* 1/2 (+ (time-hash (time-period-begin prd)) (time-hash (time-period-end prd))))) )

(define (make-time-period-comparator)
  (make-comparator time-period? time-period=? time-period<? time-period-hash) )

) ;module srfi-19-period.comparator
