;;;; srfi-19-time.comparator.scm  -*- Scheme -*-
;;;; Kon Lovett, Dec '21

(module srfi-19-time.comparator

(;export
  time-hash
  make-time-comparator)

(import scheme
  (chicken base)
  (chicken type)
  (only (chicken bitwise) bitwise-xor)
  (only (srfi 128) symbol-hash number-hash make-comparator hash-salt hash-bound)
  (only srfi-19-time time-type time-second time-nanosecond time? time=? time<? check-time))

;;;

(include-relative "srfi-19-common.types")

(: time-hash (time --> integer))
(: make-time-comparator (--> (struct comparator)))

;;;

(define (limit-hash hsh)
  (modulo (bitwise-xor hsh (hash-salt)) (hash-bound)) )

(define (time-hash tim)
  (limit-hash
    (+ (number-hash (time-second tim))
       (number-hash (time-nanosecond tim))
       (symbol-hash (time-type tim)))) )

(define (make-time-comparator)
  (make-comparator time? time=? time<? time-hash) )

) ;module srfi-19-time.comparator
